/******************************************************************************

  %name: nwdel.h %
  %version: 8 %
  %date_modified: Fri Jun 15 10:23:19 2007 %
  $Copyright:

  Copyright (c) 1989-2007 Novell, Inc.  All Rights Reserved.

  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE DEVELOPER LICENSE
  AGREEMENT OR OTHER AGREEMENT THROUGH WHICH NOVELL, INC. MAKES THE WORK
  AVAILABLE. THIS WORK MAY NOT BE ADAPTED WITHOUT NOVELL'S PRIOR WRITTEN
  CONSENT.

  NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
  INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT. NOVELL, THE AUTHORS
  OF THE WORK, AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY
  CLAIM, DAMAGES, OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT,
  OR OTHERWISE, ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK OR THE
  USE OR OTHER DEALINGS IN THE WORK.$

 *****************************************************************************/

#if ! defined ( NWDEL_H )
#define NWDEL_H

#if ! defined ( NTYPES_H )
#include "ntypes.h"
#endif

#if ! defined ( NWCALDEF_H )
#include "nwcaldef.h"
#endif

#include "npackon.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
   nuint32  sequence;
   nuint32  parent;
   nuint32  attributes;
   nuint8   uniqueID;
   nuint8   flags;
   nuint8   nameSpace;
   nuint8   nameLength;
   nuint8   name [256];
   nuint32  creationDateAndTime;
   nuint32  ownerID;
   nuint32  lastArchiveDateAndTime;
   nuint32  lastArchiverID;
   nuint32  updateDateAndTime;
   nuint32  updatorID;
   nuint32  fileSize;
   nuint8   reserved[44];
   nuint16  inheritedRightsMask;
   nuint16  lastAccessDate;
   nuint32  deletedTime;
   nuint32  deletedDateAndTime;
   nuint32  deletorID;
   nuint8   reserved3 [16];
} NWDELETED_INFO;

typedef struct
{
   nuint32  sequence;
   nuint32  parent;
   nuint32  attributes;
   nuint8   uniqueID;
   nuint8   flags;
   nuint8   nameSpace;
   nuint16  nameLength;
   nuint8   name [766];
   nuint32  creationDateAndTime;
   nuint32  ownerID;
   nuint32  lastArchiveDateAndTime;
   nuint32  lastArchiverID;
   nuint32  updateDateAndTime;
   nuint32  updatorID;
   nuint32  fileSize;
   nuint8   reserved[44];
   nuint16  inheritedRightsMask;
   nuint16  lastAccessDate;
   nuint32  deletedTime;
   nuint32  deletedDateAndTime;
   nuint32  deletorID;
   nuint8   reserved3 [16];
} NWDELETED_INFO_EXT;

typedef struct
{
   nuint64  sequence;
   nuint32  parent;
   nuint32  attributes;
   nuint8   uniqueID;
   nuint8   flags;
   nuint8   nameSpace;
   nuint16  nameLength;
   nuint8   name[766];
   nuint32  creationDateAndTime;
   nuint32  ownerID;
   nuint32  lastArchiveDateAndTime;
   nuint32  lastArchiverID;
   nuint32  updateDateAndTime;
   nuint32  updatorID;
   nuint32  fileSize;
   nuint8   reserved[44];
   nuint16  inheritedRightsMask;
   nuint16  lastAccessDate;
   nuint32  deletedTime;
   nuint32  deletedDateAndTime;
   nuint32  deletorID;
   nuint16      fileSysFlag;
   nuint8   reserved3 [16];
} NWDELETED_INFO_EXT2;

typedef struct
{
   nuint64 sequence;
   nuint16 fileSysFlag;
   nuint8  rcvrFileName[766];
   NWCCODE errorcode;
} NWRECOVER_FILE_INFO;

typedef struct
{
   nuint64 sequence;
   nuint16 fileSysFlag;
   NWCCODE errorcode;
} NWPURGE_FILE_INFO;

typedef nuint_ptr NWSCANFORDELETED_HANDLE;

N_EXTERN_LIBRARY( NWCCODE )
NWPurgeDeletedFile
(
   NWCONN_HANDLE       conn,
   NWDIR_HANDLE        dirHandle,
   nuint32             iterHandle,
   nuint32             volNum,
   nuint32             dirBase,
   const nstr8 N_FAR * fileName
);

N_EXTERN_LIBRARY(NWCCODE)
NWPurgeDeletedFile2
(
   NWCONN_HANDLE       conn,
   NWDIR_HANDLE        dirHandle,
   nuint32             volNum,
   nuint32             dirBase,
   nuint16             noOfEntries,
   NWPURGE_FILE_INFO * pPurgeFileInfo
);

N_EXTERN_LIBRARY( NWCCODE )
NWRecoverDeletedFile
(
   NWCONN_HANDLE  conn,
   NWDIR_HANDLE   dirHandle,
   nuint32        iterHandle,
   nuint32        volNum,
   nuint32        dirBase,
   pnstr8         delFileName,
   pnstr8         rcvrFileName
);

N_EXTERN_LIBRARY( NWCCODE )
NWRecoverDeletedFileExt
(
   NWCONN_HANDLE  conn,
   NWDIR_HANDLE   dirHandle,
   nuint32        iterHandle,
   nuint32        volNum,
   nuint32        dirBase,
   pnstr8         delFileName,
   pnstr8         rcvrFileName
);

N_EXTERN_LIBRARY(NWCCODE)
NWRecoverDeletedFileExt2
(
   NWCONN_HANDLE  conn,
   NWDIR_HANDLE   dirHandle,
   nuint32        volNum,
   nuint32        dirBase,
   nuint16        noOfEntries,
   NWRECOVER_FILE_INFO N_FAR * pSalvageFileInfo
);

N_EXTERN_LIBRARY( NWCCODE )
NWScanForDeletedFiles
(
   NWCONN_HANDLE  conn,
   NWDIR_HANDLE   dirHandle,
   pnuint32       iterHandle,
   pnuint32       volNum,
   pnuint32       dirBase,
   NWDELETED_INFO N_FAR * entryInfo
);

N_EXTERN_LIBRARY( NWCCODE )
NWScanForDeletedFilesExt
(
   NWCONN_HANDLE              conn,
   NWDIR_HANDLE               dirHandle,
   pnuint32                   iterHandle,
   pnuint32                   volNum,
   pnuint32                   dirBase,
   NWDELETED_INFO_EXT N_FAR * entryInfo
);

N_EXTERN_LIBRARY( NWCCODE )
NWScanForDeletedFilesExt2
(
   NWSCANFORDELETED_HANDLE *    pScanHandle,
   NWCONN_HANDLE                conn,
   NWDIR_HANDLE                 dirHandle,
   pnuint32                     pVolNum,
   pnuint32                     pDirBase,
   pnuint16                                 pNoOfEntries,
   NWDELETED_INFO_EXT2 N_FAR *  pDelectedInfoStructs
);

N_EXTERN_LIBRARY( NWCCODE )
NWCloseScanForDeletedFilesHandle
(
        NWSCANFORDELETED_HANDLE * pScanHandle
);

#ifdef __cplusplus
}
#endif

   /* The NLM LibC x-plat libraries do not support obsolete apis
   */
#include <stddef.h>
#if !defined(__NOVELL_LIBC__)
   #ifdef INCLUDE_OBSOLETE
      #include "obsolete/o_del.h"
   #endif
#endif /* !defined(__NOVELL_LIBC__) */

#include "npackoff.h"
#endif  /* NWDEL_H */
